unit unit1;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  davArrayBtn,StdCtrls, Buttons, ExtCtrls;

type
  TForm1 = class(TForm)
    Button2: TButton;
    Edit1: TEdit;
    Button3: TButton;
    Button5: TButton;
    Button6: TButton;
    SpeedButton1: TSpeedButton;
    SpeedButton2: TSpeedButton;
    SpeedButton3: TSpeedButton;
    SpeedButton4: TSpeedButton;
    Button1: TButton;
    Button7: TButton;
    StaticText1: TStaticText;
    StaticText2: TStaticText;
    Button8: TButton;
    Button9: TButton;
    StaticText4: TStaticText;
    BitBtn1: TBitBtn;
    BitBtn4: TBitBtn;
    BitBtn5: TBitBtn;
    BitBtn6: TBitBtn;
    Edit2: TEdit;
    RadioGroup1: TRadioGroup;
    BitBtn7: TBitBtn;

    procedure davBtnPaint(sender: TObject; BtnNr: Byte;
                          status: TBtnStatus);
    procedure davBtnchange(sender : TObject; BtnNr : byte;
                           status : TBtnStatus; button : TmouseButton);
    procedure davEnter(sender : TObject);
    procedure davLeave(sender : TObject);

    procedure Button1Click(Sender: TObject);
    procedure Button2Click(Sender: TObject);
    procedure Button3Click(Sender: TObject);
    procedure Button4Click(Sender: TObject);
    procedure Button5Click(Sender: TObject);
    procedure Button6Click(Sender: TObject);
    procedure SpeedButton1Click(Sender: TObject);
    procedure SpeedButton2Click(Sender: TObject);
    procedure SpeedButton3Click(Sender: TObject);
    procedure SpeedButton4Click(Sender: TObject);
    procedure Button7Click(Sender: TObject);
    procedure Button8Click(Sender: TObject);
    procedure Button9Click(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
    procedure Button10Click(Sender: TObject);
    procedure BitBtn1Click(Sender: TObject);
    procedure BitBtn4Click(Sender: TObject);
    procedure BitBtn5Click(Sender: TObject);
    procedure BitBtn6Click(Sender: TObject);
    procedure BitBtn7Click(Sender: TObject);
  private
    { Private declarations }
  public
  
  end;

var
  Form1: TForm1;

implementation

{$R *.DFM}

const mijnkleuren : TcolorTable =
                    ($000000,$ffffff,$0000ff,$00ff00,$ff0000);

var mybtn : TdavArrayBtn;

procedure TForm1.Button1Click(Sender: TObject);
begin
 mybtn.BtnShape := bs3D;
end;

procedure TForm1.Button2Click(Sender: TObject);
begin
 mybtn.BtnWidth := strtoint(edit1.text);
end;

procedure TForm1.Button3Click(Sender: TObject);
begin
 mybtn.btnspacing := strtoint(edit1.text);
end;

procedure TForm1.Button4Click(Sender: TObject);
begin
 mybtn.BtnDown(strtoint(edit1.text));
end;

procedure TForm1.Button5Click(Sender: TObject);
begin
 mybtn.columns := strtoint(edit1.text);
end;

procedure TForm1.Button6Click(Sender: TObject);
begin
 mybtn.rows := strtoint(edit1.text);
end;

procedure TForm1.SpeedButton1Click(Sender: TObject);
begin
 mybtn.btnHeight := strtoint(edit1.text);
end;

procedure TForm1.SpeedButton2Click(Sender: TObject);
begin
 mybtn.border := strtoint(edit1.text);
end;

procedure TForm1.SpeedButton3Click(Sender: TObject);
begin
 mybtn.BtnShow(strtoint(edit1.text));
end;

procedure TForm1.SpeedButton4Click(Sender: TObject);
begin
 mybtn.BtnHide(strtoint(edit1.text));
end;

procedure TForm1.Button7Click(Sender: TObject);
begin
 mybtn.BtnShape := bsFlat;
end;

procedure TForm1.Button8Click(Sender: TObject);
var status : TBtnStatus;
begin
 status := mybtn.GetBtnStatus(strtoint(edit1.text));
 case status of
  stHidden : statictext1.caption := 'hidden';
  stFlat : statictext1.caption := 'flat';
  stDown : statictext1.caption := 'down'
 end//case
end;

procedure TForm1.Button9Click(Sender: TObject);
begin
 mybtn.PColorTable := @mijnKleuren;
end;

procedure TForm1.davBtnPaint(sender: TObject; BtnNr: Byte;
                          status: TBtnStatus);
var r : Trect;
begin
  with sender as TDavArrayBtn do
   begin
    r := GetBtnRect(btnNr);
    canvas.font.Name := 'arial';
    canvas.font.height := 25;
    case status of
     stDown    : canvas.font.color := $ff00;
     stFlat    : canvas.font.color := $ff;
     stHI      : canvas.font.color := $ffff;
    end;
    canvas.brush.style := bsClear;
    canvas.textout(r.left+5,r.top+5,inttostr(btnNr));
   end;
end;

procedure TForm1.davBtnChange(sender : TObject; BtnNr : byte;
                              status : TBtnStatus; button : TmouseButton);
begin
 if button = mbleft then statictext1.caption := inttostr(BtnNr)
  else statictext2.caption := inttostr(BtnNr);
end;

procedure TForm1.davEnter(sender : TObject);
begin
 statictext4.caption := 'entered';
end;

procedure TForm1.davLeave(sender : TObject);
begin
 statictext4.caption := 'left';
end;

procedure TForm1.formcreate(sender : TObject);
begin
 myBtn := TdavArrayBtn.create(self);
  with myBtn do
   begin
    parent := self;
    left := 300;
    top := 50;
    color := $ffff;
    onBtnPaint := davBtnPaint;
    onBtnChange := davBtnChange;
    onEnter := davEnter;
    onLeave := davleave;
   end;
end;

procedure TForm1.FormDestroy(Sender: TObject);
begin
 if assigned(myBtn) then
  begin
   mybtn.destroy;
   mybtn := nil;
  end; 
end;

procedure TForm1.Button10Click(Sender: TObject);
begin
 if assigned(mybtn) then
  begin
   mybtn.destroy;
   mybtn := nil;
  end; 
end;

procedure TForm1.BitBtn1Click(Sender: TObject);
begin
 mybtn.BtnEdge := strtoint(edit1.text);
end;

procedure TForm1.BitBtn4Click(Sender: TObject);
begin
 mybtn.BtnDown(strtoint(edit1.text));
end;

procedure TForm1.BitBtn5Click(Sender: TObject);
begin
 mybtn.Btnrelease(strtoint(edit1.text));
end;

procedure TForm1.BitBtn6Click(Sender: TObject);
begin
 mybtn.setBtnGroup(strtoint(edit1.text), strtoInt(edit2.text));
end;

procedure TForm1.BitBtn7Click(Sender: TObject);
begin
 mybtn.setBtnOpMode(strtoint(edit1.text),TBtnOpMode(radiogroup1.itemindex));
end;

end.
